import * as i0 from '@angular/core';
import { Injectable, EventEmitter, Component, ViewEncapsulation, Input, Output } from '@angular/core';
import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i1 from '@angular/forms';
import { FormsModule } from '@angular/forms';
import * as i3 from '@ng-select/ng-select';
import { NgSelectModule } from '@ng-select/ng-select';

class AngularSelectPlusService {
    constructor() { }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.7", ngImport: i0, type: AngularSelectPlusService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "18.2.7", ngImport: i0, type: AngularSelectPlusService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.7", ngImport: i0, type: AngularSelectPlusService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: () => [] });

// import "node_modules/@ng-select/ng-select/themes/default.theme.css";
class AngularSelectPlusComponent {
    constructor() {
        this.items$ = null;
        this.bindLabel = 'label';
        this.bindValue = 'value';
        this.displayQuantity = 4;
        this.placeholder = '';
        this.selectedValChange = new EventEmitter();
        this.selectedVal = null;
        this.onChange = new EventEmitter();
    }
    ngOnChanges(changes) {
        // this.bindLabel = this.bindLabel || 'label';
    }
    getValue(item) {
        return item[this.bindLabel];
    }
    onChanges() {
        this.selectedValChange.emit(this.selectedVal);
        this.onChange.emit();
    }
    getCheckVal(event) {
        if (event.target.checked) {
            this.selectedVal = this.items$ && this.items$.map((x) => this.bindValue ? x[this.bindValue] : x[this.bindLabel]);
        }
        else {
            this.selectedVal = [];
        }
        this.selectedValChange.emit(this.selectedVal);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.7", ngImport: i0, type: AngularSelectPlusComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.2.7", type: AngularSelectPlusComponent, isStandalone: true, selector: "lib-angular-select-plus", inputs: { items$: ["items", "items$"], bindLabel: "bindLabel", bindValue: "bindValue", displayQuantity: "displayQuantity", placeholder: "placeholder", selectedVal: "selectedVal" }, outputs: { selectedValChange: "selectedValChange", onChange: "onChange" }, usesOnChanges: true, ngImport: i0, template: `<p>custom-ng-select</p>
    <ng-select
      class="custom-ng-select"
      id="{{placeholder}}"
      [items]="items$"
      [bindLabel]="bindLabel"
      [bindValue]="bindValue"
      [hideSelected]="false"
      [multiple]="true"
      [minTermLength]="1"
      [(ngModel)]="selectedVal"
      (change)="onChanges()"
      dropdownPosition="bottom"
      [closeOnSelect]="false"
      placeholder="{{placeholder|titlecase}}"
    >
      <ng-template ng-multi-label-tmp let-items="items" let-clear="clear">
        <ng-template #lessSelected>
          <div class="ng-value" *ngFor="let item of items | slice : 0 : displayQuantity">
            <span class="ng-value-label">{{ getValue(item) }}</span>
            <span
              class="ng-value-icon right"
              (click)="clear(item)"
              aria-hidden="true"
              >×</span
            >
          </div>
          <div class="ng-value" *ngIf="items.length > displayQuantity">
            <span class="ng-value-label">{{ items.length - displayQuantity }} more...</span>
          </div>
        </ng-template>

        <ng-container *ngIf="items.length === items$?.length; else lessSelected">
          <div class="ng-value">
            <span class="ng-value-label"
              >{{ items.length }} of {{ items$?.length }} Selected</span
            >
          </div>
        </ng-container>
      </ng-template>
      <ng-template ng-header-tmp>
        <div class="form-check form-check-inline">
          <input
            class="form-check-input"
            type="checkbox"
            [checked]="selectedVal?.length === items$?.length"
            (change)="getCheckVal($event)"
            id="inlineCheckbox1"
          />
          <label for="inlineCheckbox1">Select All</label>
        </div>
      </ng-template>
      <ng-template ng-footer-tmp>
        Selected count:
        {{ selectedVal?.length }}
      </ng-template>
    </ng-select>

  `, isInline: true, styles: [".custom-ng-select .ng-dropdown-panel .ng-dropdown-panel-items .ng-option{border-bottom:1px solid rgba(92,168,219,.5843137255)}.custom-ng-select .ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-marked{background-color:#a31515;color:#fff;font-weight:700}.custom-ng-select .ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-marked .cus_phone,.custom-ng-select .ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-marked .cus_pport>div:first-child,.custom-ng-select .ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-marked .cus_eid>div:first-child{color:#fff}\n"], dependencies: [{ kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "pipe", type: i2.SlicePipe, name: "slice" }, { kind: "pipe", type: i2.TitleCasePipe, name: "titlecase" }, { kind: "ngmodule", type: NgSelectModule }, { kind: "component", type: i3.NgSelectComponent, selector: "ng-select", inputs: ["bindLabel", "bindValue", "ariaLabel", "markFirst", "placeholder", "fixedPlaceholder", "notFoundText", "typeToSearchText", "preventToggleOnRightClick", "addTagText", "loadingText", "clearAllText", "appearance", "dropdownPosition", "appendTo", "loading", "closeOnSelect", "hideSelected", "selectOnTab", "openOnEnter", "maxSelectedItems", "groupBy", "groupValue", "bufferAmount", "virtualScroll", "selectableGroup", "selectableGroupAsModel", "searchFn", "trackByFn", "clearOnBackspace", "labelForId", "inputAttrs", "tabIndex", "readonly", "searchWhileComposing", "minTermLength", "editableSearchTerm", "ngClass", "typeahead", "multiple", "addTag", "searchable", "clearable", "isOpen", "items", "compareWith", "clearSearchOnAdd", "deselectOnClick", "keyDownFn"], outputs: ["blur", "focus", "change", "open", "close", "search", "clear", "add", "remove", "scroll", "scrollToEnd"] }, { kind: "directive", type: i3.NgMultiLabelTemplateDirective, selector: "[ng-multi-label-tmp]" }, { kind: "directive", type: i3.NgHeaderTemplateDirective, selector: "[ng-header-tmp]" }, { kind: "directive", type: i3.NgFooterTemplateDirective, selector: "[ng-footer-tmp]" }], encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.7", ngImport: i0, type: AngularSelectPlusComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-angular-select-plus', standalone: true, imports: [FormsModule, CommonModule, NgSelectModule], template: `<p>custom-ng-select</p>
    <ng-select
      class="custom-ng-select"
      id="{{placeholder}}"
      [items]="items$"
      [bindLabel]="bindLabel"
      [bindValue]="bindValue"
      [hideSelected]="false"
      [multiple]="true"
      [minTermLength]="1"
      [(ngModel)]="selectedVal"
      (change)="onChanges()"
      dropdownPosition="bottom"
      [closeOnSelect]="false"
      placeholder="{{placeholder|titlecase}}"
    >
      <ng-template ng-multi-label-tmp let-items="items" let-clear="clear">
        <ng-template #lessSelected>
          <div class="ng-value" *ngFor="let item of items | slice : 0 : displayQuantity">
            <span class="ng-value-label">{{ getValue(item) }}</span>
            <span
              class="ng-value-icon right"
              (click)="clear(item)"
              aria-hidden="true"
              >×</span
            >
          </div>
          <div class="ng-value" *ngIf="items.length > displayQuantity">
            <span class="ng-value-label">{{ items.length - displayQuantity }} more...</span>
          </div>
        </ng-template>

        <ng-container *ngIf="items.length === items$?.length; else lessSelected">
          <div class="ng-value">
            <span class="ng-value-label"
              >{{ items.length }} of {{ items$?.length }} Selected</span
            >
          </div>
        </ng-container>
      </ng-template>
      <ng-template ng-header-tmp>
        <div class="form-check form-check-inline">
          <input
            class="form-check-input"
            type="checkbox"
            [checked]="selectedVal?.length === items$?.length"
            (change)="getCheckVal($event)"
            id="inlineCheckbox1"
          />
          <label for="inlineCheckbox1">Select All</label>
        </div>
      </ng-template>
      <ng-template ng-footer-tmp>
        Selected count:
        {{ selectedVal?.length }}
      </ng-template>
    </ng-select>

  `, encapsulation: ViewEncapsulation.None, styles: [".custom-ng-select .ng-dropdown-panel .ng-dropdown-panel-items .ng-option{border-bottom:1px solid rgba(92,168,219,.5843137255)}.custom-ng-select .ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-marked{background-color:#a31515;color:#fff;font-weight:700}.custom-ng-select .ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-marked .cus_phone,.custom-ng-select .ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-marked .cus_pport>div:first-child,.custom-ng-select .ng-dropdown-panel .ng-dropdown-panel-items .ng-option.ng-option-marked .cus_eid>div:first-child{color:#fff}\n"] }]
        }], ctorParameters: () => [], propDecorators: { items$: [{
                type: Input,
                args: ['items']
            }], bindLabel: [{
                type: Input
            }], bindValue: [{
                type: Input
            }], displayQuantity: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], selectedValChange: [{
                type: Output
            }], selectedVal: [{
                type: Input
            }], onChange: [{
                type: Output
            }] } });

/*
 * Public API Surface of angular-select-plus
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AngularSelectPlusComponent, AngularSelectPlusService };
//# sourceMappingURL=angular-select-plus.mjs.map
